Loading...
Searching...
No Matches
pod_vector< T > Class Template Reference

## Public Types

typedef T * | iterator
typedef const T * | const_iterator
typedef T | value_type
typedef size_t | size_type
typedef T & | reference
typedef const T & | const_reference

## Public Member Functions

| pod_vector (size_t initial_size=16)
| pod_vector (const pod_vector< T > &other)=delete
pod_vector & | operator= (const pod_vector< T > &other)=delete
pod_vector & | operator= (pod_vector< T > &&other)
| pod_vector (pod_vector< T > &&other)
| pod_vector (unsafe_pod_vector< T > &&other)
void | fast_reserve (size_t n)
void | reserve (size_t n)
void | resize (size_t new_size)
void | resize_and_wipe (size_t new_size)
ISOSPEC_FORCE_INLINE void | nocheck_push_back (const T &val) noexcept
ISOSPEC_FORCE_INLINE void | push_back (const T &val)
ISOSPEC_FORCE_INLINE T & | operator[] (size_t n) noexcept
ISOSPEC_FORCE_INLINE const T & | operator[] (size_t n) const noexcept
ISOSPEC_FORCE_INLINE size_t | size () const noexcept
ISOSPEC_FORCE_INLINE size_t | capacity () const noexcept
ISOSPEC_FORCE_INLINE T * | data () noexcept
ISOSPEC_FORCE_INLINE const T * | data () const noexcept
ISOSPEC_FORCE_INLINE bool | empty () const noexcept
ISOSPEC_FORCE_INLINE const T & | back () const noexcept
ISOSPEC_FORCE_INLINE void | pop_back () noexcept
void | swap (pod_vector< T > &other) noexcept
iterator | begin () noexcept
const_iterator | begin () const noexcept
const_iterator | cbegin () const noexcept
iterator | end () noexcept
const_iterator | end () const noexcept
const_iterator | cend () const noexcept
ISOSPEC_FORCE_INLINE const T & | front () const noexcept
void | clear ()

## Friends

class | unsafe_pod_vector< T >

## Detailed Description

template<typename T>
class pod_vector< T >

Definition at line 32 of file pod_vector.h.

## Member Typedef Documentation

## const_iterator

template<typename T>

typedef const T* pod_vector< T >::const_iterator

Definition at line 195 of file pod_vector.h.

## const_reference

template<typename T>

typedef const T& pod_vector< T >::const_reference

Definition at line 199 of file pod_vector.h.

## iterator

template<typename T>

typedef T* pod_vector< T >::iterator

Definition at line 194 of file pod_vector.h.

## reference

template<typename T>

typedef T& pod_vector< T >::reference

Definition at line 198 of file pod_vector.h.

## size_type

template<typename T>

typedef size_t pod_vector< T >::size_type

Definition at line 197 of file pod_vector.h.

## value_type

template<typename T>

typedef T pod_vector< T >::value_type

Definition at line 196 of file pod_vector.h.

## Constructor & Destructor Documentation

## pod_vector() [1/3]

template<typename T>

pod_vector< T >::pod_vector | ( | size_t | initial_size = 16 | ) |

inline explicit

Definition at line 39 of file pod_vector.h.

## pod_vector() [2/3]

template<typename T>

pod_vector< T >::pod_vector | ( | pod_vector< T > && | other | ) |

inline

Definition at line 64 of file pod_vector.h.

## ~pod_vector()

template<typename T>

pod_vector< T >::~pod_vector | ( |  | ) |

inline

Definition at line 72 of file pod_vector.h.

## pod_vector() [3/3]

template<typename T>

pod_vector< T >::pod_vector | ( | unsafe_pod_vector< T > && | other | ) |

inline explicit

Definition at line 74 of file pod_vector.h.

## Member Function Documentation

## back()

template<typename T>

ISOSPEC_FORCE_INLINE const T & pod_vector< T >::back | ( |  | ) | const

inline noexcept

Definition at line 174 of file pod_vector.h.

## begin() [1/2]

template<typename T>

const_iterator pod_vector< T >::begin | ( |  | ) | const

inline noexcept

Definition at line 202 of file pod_vector.h.

## begin() [2/2]

template<typename T>

iterator pod_vector< T >::begin | ( |  | ) |

inline noexcept

Definition at line 201 of file pod_vector.h.

## capacity()

template<typename T>

ISOSPEC_FORCE_INLINE size_t pod_vector< T >::capacity | ( |  | ) | const

inline noexcept

Definition at line 154 of file pod_vector.h.

## cbegin()

template<typename T>

const_iterator pod_vector< T >::cbegin | ( |  | ) | const

inline noexcept

Definition at line 203 of file pod_vector.h.

## cend()

template<typename T>

const_iterator pod_vector< T >::cend | ( |  | ) | const

inline noexcept

Definition at line 206 of file pod_vector.h.

## clear()

template<typename T>

void pod_vector< T >::clear | ( |  | ) |

inline

Definition at line 214 of file pod_vector.h.

## data() [1/2]

template<typename T>

ISOSPEC_FORCE_INLINE const T * pod_vector< T >::data | ( |  | ) | const

inline noexcept

Definition at line 164 of file pod_vector.h.

## data() [2/2]

template<typename T>

ISOSPEC_FORCE_INLINE T * pod_vector< T >::data | ( |  | ) |

inline noexcept

Definition at line 159 of file pod_vector.h.

## empty()

template<typename T>

ISOSPEC_FORCE_INLINE bool pod_vector< T >::empty | ( |  | ) | const

inline noexcept

Definition at line 169 of file pod_vector.h.

## end() [1/2]

template<typename T>

const_iterator pod_vector< T >::end | ( |  | ) | const

inline noexcept

Definition at line 205 of file pod_vector.h.

## end() [2/2]

template<typename T>

iterator pod_vector< T >::end | ( |  | ) |

inline noexcept

Definition at line 204 of file pod_vector.h.

## fast_reserve()

template<typename T>

void pod_vector< T >::fast_reserve | ( | size_t | n | ) |

inline

Definition at line 82 of file pod_vector.h.

## front()

template<typename T>

ISOSPEC_FORCE_INLINE const T & pod_vector< T >::front | ( |  | ) | const

inline noexcept

Definition at line 208 of file pod_vector.h.

## nocheck_push_back()

template<typename T>

ISOSPEC_FORCE_INLINE void pod_vector< T >::nocheck_push_back | ( | const T & | val | ) |

inline noexcept

Definition at line 122 of file pod_vector.h.

## operator=()

template<typename T>

pod_vector & pod_vector< T >::operator= | ( | pod_vector< T > && | other | ) |

inline

Definition at line 54 of file pod_vector.h.

## operator[]() [1/2]

template<typename T>

ISOSPEC_FORCE_INLINE const T & pod_vector< T >::operator[] | ( | size_t | n | ) | const

inline noexcept

Definition at line 143 of file pod_vector.h.

## operator[]() [2/2]

template<typename T>

ISOSPEC_FORCE_INLINE T & pod_vector< T >::operator[] | ( | size_t | n | ) |

inline noexcept

Definition at line 137 of file pod_vector.h.

## pop_back()

template<typename T>

ISOSPEC_FORCE_INLINE void pod_vector< T >::pop_back | ( |  | ) |

inline noexcept

Definition at line 180 of file pod_vector.h.

## push_back()

template<typename T>

ISOSPEC_FORCE_INLINE void pod_vector< T >::push_back | ( | const T & | val | ) |

inline

Definition at line 129 of file pod_vector.h.

## reserve()

template<typename T>

void pod_vector< T >::reserve | ( | size_t | n | ) |

inline

Definition at line 94 of file pod_vector.h.

## resize()

template<typename T>

void pod_vector< T >::resize | ( | size_t | new_size | ) |

inline

Definition at line 100 of file pod_vector.h.

## resize_and_wipe()

template<typename T>

void pod_vector< T >::resize_and_wipe | ( | size_t | new_size | ) |

inline

Definition at line 114 of file pod_vector.h.

## size()

template<typename T>

ISOSPEC_FORCE_INLINE size_t pod_vector< T >::size | ( |  | ) | const

inline noexcept

Definition at line 149 of file pod_vector.h.

## swap()

template<typename T>

void pod_vector< T >::swap | ( | pod_vector< T > & | other | ) |

inline noexcept

Definition at line 187 of file pod_vector.h.

## Friends And Related Symbol Documentation

## unsafe_pod_vector< T >

template<typename T>

friend class unsafe_pod_vector< T >

friend

Definition at line 214 of file pod_vector.h.

The documentation for this class was generated from the following file:

- /build/isospec-8QB56o/isospec-2.3.2/src/IsoSpec++/pod_vector.h